import gtk
from vmdisks.disks import disk_protocols

def chooser(dialog_name, topwin, mode=gtk.FILE_CHOOSER_ACTION_OPEN,
            file=None, folder=None, type=None):
    fcdialog = gtk.FileChooserDialog(dialog_name, topwin, mode,
                                     (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                                     gtk.STOCK_OPEN, gtk.RESPONSE_ACCEPT))
    if file:
        index=0
        filename = file
        while index < len(disk_protocols):
            if file.startswith(disk_protocols[index]):
                filename = file[len(disk_protocols[index]):]
                break
            index += 1
        file = filename
        fcdialog.set_filename(file)
    if folder:
        fcdialog.set_current_folder(folder)
    if mode == gtk.FILE_CHOOSER_ACTION_SAVE:
        fcdialog.set_do_overwrite_confirmation(True)
    if type != None:
        f = gtk.FileFilter()
        f.add_pattern("*." + type)
        fcdialog.set_filter(f)
    response = fcdialog.run()
    fcdialog.hide()
    if response == gtk.RESPONSE_ACCEPT:
        filename = fcdialog.get_filename()
        folder = fcdialog.get_current_folder()
        fcdialog.destroy()
        return (filename, folder)
    else:
        fcdialog.destroy()
        return (None, None)

